;;;********************************************************************
;;;                     
;;;                        
;;;                            KS_OtvP.LSP v.1
;;;                        AutoCAD 2000 (15)
;;;                 Copyright,2002        ..
;;;                               3.07.02
;;;********************************************************************

(defun c:ks_otvp ( / pr p3 p4 p5 d d1 cmd1 blm)
  (setq d	nil
        cmd	(getvar "CMDECHO")
        blm	(getvar "BLIPMODE")
	oldtp	(getvar "celtype")
	oldcl	(getvar "cecolor")
	sosnap	(getvar "osmode")
	nam1	(findfile "support/ks_otv/ks_otvp.dcl")
	dcl_id	(load_dialog nam1)
	case	"or"
	re	"0"
	ng	1
	nv	1
	akv	0
	bkv	0
  ) 

  (if (new_dialog "otvp" dcl_id)
    (progn
      (mode_tile "d1" 1)
      (action_tile "kgor" "(setq ng1 $value ng (1+ (atoi ng1)))")
      (action_tile "kver" "(setq nv1 $value nv (1+ (atoi nv1)))")
      (action_tile "akv1" "(setq akv2 $value akv (atof akv2))")
      (action_tile "bkv1" "(setq bkv2 $value bkv (atof bkv2))")
      (action_tile "vo" "(progn (setq case $value) (votv_op))")
      (action_tile "d1" "(setq d2 $value d (atof d2))")
      (action_tile "m1" "(setq re $value)")
      (action_tile "accept" "(okey_op)")
      (action_tile "cancel" "(progn (setq wrong1 0) (done_dialog 0))")
      (action_tile "help" "(abpr_op)")
      (start_dialog)
      (unload_dialog dcl_id)
    )
    (exit)
  )
  (if (/= wrong1 0) (otris_op))
  
  (setvar "cmdecho" cmd)
  (setvar "blipmode" blm)
  (setvar "osmode" sosnap)
  (setq  p1 nil   p2 nil   p3 nil p4 nil p5 nil akv nil  bkv nil 
         d nil d1 nil cmd nil blm nil oldtp nil oldcl nil sosnap nil
         help_pr_o nil case nil nam nil nam1 nil ng nil nv nil re nil
         n1 nil n2 nil j1 nil j2 nil wrong1 nil
  )
  (princ)
)

;=====    =====

(defun okey_op ()
  (setq wrong1 1)
  (cond ((and (= ng 1) (= nv 1))
	 (progn (set_tile "atten" "     ") (setq wrong1 0)))
	((and (or (= ng 1) (= nv 1)) (or (and (> akv 0.0) (> bkv 0.0)) (and (<= akv 0.0) (<= bkv 0.0))))
	 (progn (set_tile "atten" "      ?") (setq wrong1 0)))
	((and (> ng 1) (= nv 1) (> bkv 0.0))
	 (progn (set_tile "atten" "      ?") (setq wrong1 0)))
	((and (= ng 1) (> nv 1) (> akv 0.0))
	 (progn (set_tile "atten" "      ?") (setq wrong1 0)))	
	((and (= case "od") (<= d 0.0))
	 (progn (set_tile "atten" "   ") (setq wrong1 0)))
	((and (/= ng 1) (/= nv 1) (< akv 0))
	 (progn (set_tile "atten" "     ") (setq wrong1 0)))
	((and (/= ng 1) (/= nv 1) (< bkv 0))
	 (progn (set_tile "atten" "     ") (setq wrong1 0)))
  )
  (if (/= wrong1 0) (done_dialog))
)

;=====  =====

(defun votv_op ()
   (cond
      ((= case "or") (progn (mode_tile "m1" 0) (mode_tile "d1" 1)))
      ((= case "od") (progn (mode_tile "d1" 0) (mode_tile "m1" 1)))
   )
)

;==========

(defun otris_op ()
  (cond	((= case "od") (progn (setq d (/ d 2)) (rotv_op)))
	((= case "or") (progn (update_op) (rotv_op) (rarc_op)))
  )
)

;===== =====

(defun update_op ()
  (setq	nam	(findfile "support/ks_otv/ks_otv.dat")
 	x	(open nam "r")
	a	(read-line x)
	aa	(read a)
  )
  (cond	((= re "0") (setq r1 (cdr (assoc 'M3 aa))))
	((= re "1") (setq r1 (cdr (assoc 'M4 aa))))
	((= re "2") (setq r1 (cdr (assoc 'M5 aa))))
	((= re "3") (setq r1 (cdr (assoc 'M6 aa))))
	((= re "4") (setq r1 (cdr (assoc 'M8 aa))))
	((= re "5") (setq r1 (cdr (assoc 'M10 aa))))
	((= re "6") (setq r1 (cdr (assoc 'M12 aa))))
	((= re "7") (setq r1 (cdr (assoc 'M16 aa))))
	((= re "8") (setq r1 (cdr (assoc 'M20 aa))))
  )
  (setq r    (atof (car r1))
        d    (atof (cadr r1))
  )
)

;=====    =====

(defun rotv_op ()
  (setq p1	(getpoint "\n : ")
	p2	(list (-(car p1)  (/ akv 2.0)) (-(cadr p1) (/ bkv 2.0)))
	p3	(list (car p2)        (+(cadr p2) bkv))
        p4	(list (+(car p3) akv) (cadr p3)       )
        p5	(list (car p4)        (cadr p2)       )
	n1	(1- nv)
	n2	(1- ng)	
	d1	(+ d 5)
  )
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "osmode" 0)
  (cond ((= akv 0)
	 (progn
	   (setq j1 0)
	    (setvar "celtype" "ACAD_ISO10W100")
	    (setvar "cecolor" "red")
	    (command "line"
		     (list (car p2) (- (cadr p2) d1))
		     (list (car p3) (+ (cadr p3) d1))
		     ""
            )
	    (setvar "celtype" oldtp)
	    (setvar "cecolor" oldcl)
	    (while (< j1 (1+ n1))
	      (progn
		(command "circle"
			 (list (car p2) (+ (cadr p2) (* (/ bkv n1) j1))) d)
		(setvar "celtype" "ACAD_ISO10W100")
		(setvar "cecolor" "red")
		(command "line"
			 (list (- (car p2) d1) (+ (cadr p2) (* (/ bkv n1) j1)))
			 (list (+ (car p2) d1) (+ (cadr p2) (* (/ bkv n1) j1)))
			 ""
		)
		(setvar "celtype" oldtp)
		(setvar "cecolor" oldcl)
		(setq j1 (1+ j1))
	      )
            )
         )
	)
	((= bkv 0)
	 (progn
	   (setq j2 0)
	   (setvar "celtype" "ACAD_ISO10W100")
	   (setvar "cecolor" "red")
	   (command "line"
		    (list (- (car p2) d1) (cadr p2))
		    (list (+ (car p5) d1) (cadr p5))
		    ""
  	   )
	   (setvar "celtype" oldtp)
	   (setvar "cecolor" oldcl)
	   (while (< j2 (1+ n2))
	     (progn
	       (command "circle"
			(list (+ (car p2) (* (/ akv n2) j2)) (cadr p2)) d)
	       (setvar "celtype" "ACAD_ISO10W100")
	       (setvar "cecolor" "red")
	       (command "line"
			(list (+ (car p2) (* (/ akv n2) j2)) (- (cadr p2) d1))
			(list (+ (car p2) (* (/ akv n2) j2)) (+ (cadr p2) d1))
			""
	       )
	       (setvar "celtype" oldtp)
	       (setvar "cecolor" oldcl)
	       (setq j2 (1+ j2))
	     )
           )
	  )
	 )
	((and (> akv 0) (> bkv 0))
  ;===== ""===== 
         (progn
	  (setq j1 1 j2 1)
	  (command "circle" p2 d)
	  (command "circle" p3 d)
	  (command "circle" p4 d)
	  (command "circle" p5 d)
	  (setvar "celtype" "ACAD_ISO10W100")
	  (setvar "cecolor" "red")
	  (command "line"
		   (list (car p2) (- (cadr p2) d1))
		   (list (car p3) (+ (cadr p3) d1))
		   ""
          )
	  (command "line"
		   (list (- (car p3) d1) (cadr p3))
		   (list (+ (car p4) d1) (cadr p4))
		   ""
          )
	  (command "line"
		   (list (car p5) (- (cadr p5) d1))
		   (list (car p4) (+ (cadr p4) d1))
		   ""
  	  )
	  (command "line"
		   (list (- (car p2) d1) (cadr p2))
		   (list (+ (car p5) d1) (cadr p5))
		   ""
          )
	  (setvar "celtype" oldtp)
	  (setvar "cecolor" oldcl)
     ;=====  =====
          (while (< j1 n1)
	    (progn
	      (command "circle"
		       (list (car p2) (+ (cadr p2) (* (/ bkv n1) j1))) d)
	      (command "circle"
		       (list (car p5) (+ (cadr p5) (* (/ bkv n1) j1))) d)
	      (setvar "celtype" "ACAD_ISO10W100")
	      (setvar "cecolor" "red")
	      (command "line"
		       (list (- (car p2) d1) (+ (cadr p2) (* (/ bkv n1) j1)))
		       (list (+ (car p5) d1) (+ (cadr p5) (* (/ bkv n1) j1)))
		       ""
              )
	      (setvar "celtype" oldtp)
	      (setvar "cecolor" oldcl)
	      (setq j1 (1+ j1))
  	    )
          )

	  (while (< j2 n2)
	    (progn
	      (command "circle"
		       (list (+ (car p2) (* (/ akv n2) j2)) (cadr p2)) d)
	      (command "circle"
		       (list (+ (car p3) (* (/ akv n2) j2)) (cadr p3)) d)
	      (setvar "celtype" "ACAD_ISO10W100")
	      (setvar "cecolor" "red")
	      (command "line"
		       (list (+ (car p2) (* (/ akv n2) j2)) (- (cadr p2) d1))
		       (list (+ (car p3) (* (/ akv n2) j2)) (+ (cadr p3) d1))
		       ""
              )
	      (setvar "celtype" oldtp)
	      (setvar "cecolor" oldcl)
	      (setq j2 (1+ j2))
            )
          )
         )
        )
  )
)
;===== =====

(defun rarc_op ()
  (setvar "cecolor" "red")
  (cond ((= akv 0)
	 (progn
	   (setq j1 0)
	   (while (< j1 (1+ n1))
	     (command "arc"
		      (list (car p2) (+ (cadr p2) (* (/ bkv n1) j1) r))
		      "_c" (list (car p2) (+ (cadr p2) (* (/ bkv n1) j1))) "_a" 270)
	     (setq j1 (1+ j1))
           )
	 )
	)
	((= bkv 0)
	 (progn
	   (setq j2 0)
	   (while (< j2 (1+ n2))
	     (command "arc"
		      (list (+ (car p2) (* (/ akv n2) j2)) (+ (cadr p2) r))
		      "_c" (list (+ (car p2) (* (/ akv n2) j2)) (cadr p2)) "_a" 270)
	     (setq j2 (1+ j2))
           )
	 )
	)
	((and (> akv 0) (> bkv 0))
	 (progn
	   (command "arc" (list (car p2) (+ (cadr p2) r)) "_c" p2 "_a" 270)
	   (command "arc" (list (car p3) (+ (cadr p3) r)) "_c" p3 "_a" 270)
	   (command "arc" (list (car p4) (+ (cadr p4) r)) "_c" p4 "_a" 270)
	   (command "arc" (list (car p5) (+ (cadr p5) r)) "_c" p5 "_a" 270)
	   (setq j1	1
		 j2	1)
	   (while (< j1 n1)
	     (command "arc"
		      (list (car p2) (+ (cadr p2) (* (/ bkv n1) j1) r))
		      "_c" (list (car p2) (+ (cadr p2) (* (/ bkv n1) j1))) "_a" 270)
	     (command "arc"
		      (list (car p5) (+ (cadr p5) (* (/ bkv n1) j1) r))
		      "_c" (list (car p5) (+ (cadr p5) (* (/ bkv n1) j1))) "_a" 270)
	     (setq j1 (1+ j1))
           )
	   (while (< j2 n2)
	     (command "arc"
		      (list (+ (car p2) (* (/ akv n2) j2)) (+ (cadr p2) r))
		      "_c" (list (+ (car p2) (* (/ akv n2) j2)) (cadr p2)) "_a" 270)
	     (command "arc"
		      (list (+ (car p3) (* (/ akv n2) j2)) (+ (cadr p3) r))
		      "_c" (list (+ (car p3) (* (/ akv n2) j2)) (cadr p3)) "_a" 270)
	     (setq j2 (1+ j2))
           )

         )
	)
  )
  (setvar "cecolor" oldcl)
)
;===== ""=====

(defun abpr_op ( )
  (setq help_pr_o
    (list ""
          "                                 "
	  ""
	  "      , "
	  "        ."
	  ""
	  "     :  "
	  "         , "
	  "     E-mail: klf02@yandex.ru"
   )
  )
  (if (not (new_dialog "ab_text" DCL_ID)) (exit))
  (start_list "ab_progr")
  (mapcar 'add_list help_pr_o)
  (end_list)
  (action_tile  "accept" "(done_dialog)")
  (start_dialog)
)